;;; 40mule-ucs.el --- Debian mule-ucs startup file  -*-mode: emacs-lisp;-*-

;; Author: Tatsuya Kinoshita <tats@vega.ocn.ne.jp>
;; Created: 12 Nov 2002
;; Revised:  8 Nov 2006

;; Unlimited permission is granted to use, copy, distribute, and/or modify
;; this file.  There is NO WARRANTY.

;;; Code:

(let ((path (concat "/usr/share/" (symbol-name flavor) "/site-lisp/mule-ucs"))
      (case-fold-search t)
      env unicode-flag jisx0213-flag prefer-latin-flag)
  (cond
   ((and (file-exists-p (concat path "/un-define.elc"))
	 (featurep 'mule)
	 (boundp 'emacs-major-version)
	 (>= emacs-major-version 20))
    (if (fboundp 'debian-pkg-add-load-path-item)
	(debian-pkg-add-load-path-item path)
      (setq load-path (cons path load-path)))
    ;;
    (defun un-define-debian-jisx0213 ()
      "Enable Mule-UCS-Unicode for Debian system.
jisx0213 is on.  prefer-latin is off."
      (interactive)
      (un-define-debian t nil))

    (defun un-define-debian-jisx0213-latin ()
      "Enable Mule-UCS-Unicode for Debian system.
jisx0213 is on.  prefer-latin is on."
      (interactive)
      (un-define-debian t t))

    (defun un-define-debian-latin ()
      "Enable Mule-UCS-Unicode for Debian system.
jisx0213 is off.  prefer-latin is on."
      (interactive)
      (un-define-debian nil t))

    (defun un-define-debian (&optional jisx0213-flag prefer-latin-flag)
      "Enable Mule-UCS-Unicode for Debian system.
If jisx0213-flag is non-nil, jisx0213 is enabled.
If prefer-latin-flag is non-nil, latin characters are prefered rather than
CJK locale characters."
      (interactive)
      (if (featurep 'xemacs)
	  () ;; `un-define-change-charset-order' doesn't work on XEmacs
	(setq unicode-basic-translation-charset-order-list
	  (let ((case-fold-search t)
		cand elem result locale vars)
	    (setq vars '("LC_ALL" "LC_CTYPE" "LANG"))
	    (while (and vars (not (setq locale (getenv (car vars)))))
	      (setq vars (cdr vars)))
	    (or locale (setq locale "C"))
	    (setq cand
		  (append
		   '(ascii)
		   (if prefer-latin-flag
		       '(latin-iso8859-1
			 latin-iso8859-2
			 latin-iso8859-3
			 latin-iso8859-4
			 cyrillic-iso8859-5
			 ;;arabic-iso8859-6
			 greek-iso8859-7
			 hebrew-iso8859-8
			 latin-iso8859-9
			 latin-iso8859-14
			 latin-iso8859-15
			 ipa
			 mule-unicode-0100-24ff))
		   (cond
		    ((string-match "^ja" locale)
		     (append
		      '(japanese-jisx0208)
		      (if (not prefer-latin-flag)
			  '(latin-iso8859-1
			    latin-iso8859-2
			    latin-iso8859-3
			    latin-iso8859-4
			    cyrillic-iso8859-5
			    ;;arabic-iso8859-6
			    greek-iso8859-7
			    hebrew-iso8859-8
			    latin-iso8859-9
			    latin-iso8859-14
			    latin-iso8859-15
			    ipa
			    mule-unicode-0100-24ff))
		      (if jisx0213-flag '(japanese-jisx0213-1
					  japanese-jisx0213-2))
		      '(japanese-jisx0212
			korean-ksc5601
			chinese-gb2312
			chinese-cns11643-1
			chinese-cns11643-2
			chinese-cns11643-3
			chinese-cns11643-4
			chinese-cns11643-5
			chinese-cns11643-6
			chinese-cns11643-7
			chinese-big5-1
			chinese-big5-2)))
		    ((string-match "^ko" locale)
		     (append
		      '(korean-ksc5601)
		      (if (not prefer-latin-flag)
			  '(latin-iso8859-1
			    latin-iso8859-2
			    latin-iso8859-3
			    latin-iso8859-4
			    cyrillic-iso8859-5
			    ;;arabic-iso8859-6
			    greek-iso8859-7
			    hebrew-iso8859-8
			    latin-iso8859-9
			    latin-iso8859-14
			    latin-iso8859-15
			    ipa
			    mule-unicode-0100-24ff))
		      '(japanese-jisx0208)
		      (if jisx0213-flag '(japanese-jisx0213-1
					  japanese-jisx0213-2))
		      '(japanese-jisx0212
			chinese-gb2312
			chinese-cns11643-1
			chinese-cns11643-2
			chinese-cns11643-3
			chinese-cns11643-4
			chinese-cns11643-5
			chinese-cns11643-6
			chinese-cns11643-7
			chinese-big5-1
			chinese-big5-2)))
		    ((string-match "^zh.*[._]big5" locale)
		     (append
		      '(chinese-big5-1
			chinese-big5-2)
		      (if (not prefer-latin-flag)
			  '(latin-iso8859-1
			    latin-iso8859-2
			    latin-iso8859-3
			    latin-iso8859-4
			    cyrillic-iso8859-5
			    ;;arabic-iso8859-6
			    greek-iso8859-7
			    hebrew-iso8859-8
			    latin-iso8859-9
			    latin-iso8859-14
			    latin-iso8859-15
			    ipa
			    mule-unicode-0100-24ff))
		      '(chinese-gb2312
			chinese-cns11643-1
			chinese-cns11643-2
			chinese-cns11643-3
			chinese-cns11643-4
			chinese-cns11643-5
			chinese-cns11643-6
			chinese-cns11643-7
			korean-ksc5601
			japanese-jisx0208)
		      (if jisx0213-flag '(japanese-jisx0213-1
					  japanese-jisx0213-2))
		      '(japanese-jisx0212)))
		    ((string-match "^zh_tw\\>" locale)
		     (append
		      '(chinese-cns11643-1
			chinese-cns11643-2
			chinese-cns11643-3
			chinese-cns11643-4
			chinese-cns11643-5
			chinese-cns11643-6
			chinese-cns11643-7)
		      (if (not prefer-latin-flag)
			  '(latin-iso8859-1
			    latin-iso8859-2
			    latin-iso8859-3
			    latin-iso8859-4
			    cyrillic-iso8859-5
			    ;;arabic-iso8859-6
			    greek-iso8859-7
			    hebrew-iso8859-8
			    latin-iso8859-9
			    latin-iso8859-14
			    latin-iso8859-15
			    ipa
			    mule-unicode-0100-24ff))
		      '(chinese-gb2312
			chinese-big5-1
			chinese-big5-2
			korean-ksc5601
			japanese-jisx0208)
		      (if jisx0213-flag '(japanese-jisx0213-1
					  japanese-jisx0213-2))
		      '(japanese-jisx0212)))
		    ((string-match "^zh" locale)
		     (append
		      '(chinese-gb2312)
		      (if (not prefer-latin-flag)
			  '(latin-iso8859-1
			    latin-iso8859-2
			    latin-iso8859-3
			    latin-iso8859-4
			    cyrillic-iso8859-5
			    ;;arabic-iso8859-6
			    greek-iso8859-7
			    hebrew-iso8859-8
			    latin-iso8859-9
			    latin-iso8859-14
			    latin-iso8859-15
			    ipa
			    mule-unicode-0100-24ff))
		      '(chinese-cns11643-1
			chinese-cns11643-2
			chinese-cns11643-3
			chinese-cns11643-4
			chinese-cns11643-5
			chinese-cns11643-6
			chinese-cns11643-7
			chinese-big5-1
			chinese-big5-2
			korean-ksc5601
			japanese-jisx0208)
		      (if jisx0213-flag '(japanese-jisx0213-1
					  japanese-jisx0213-2))
		      '(japanese-jisx0212)))
		    (t
		     (append
		      (if (not prefer-latin-flag)
			  '(latin-iso8859-1
			    latin-iso8859-2
			    latin-iso8859-3
			    latin-iso8859-4
			    cyrillic-iso8859-5
			    ;;arabic-iso8859-6
			    greek-iso8859-7
			    hebrew-iso8859-8
			    latin-iso8859-9
			    latin-iso8859-14
			    latin-iso8859-15
			    ipa
			    mule-unicode-0100-24ff))
		      '(japanese-jisx0208)
		      (if jisx0213-flag '(japanese-jisx0213-1
					  japanese-jisx0213-2))
		      '(japanese-jisx0212
			chinese-gb2312
			chinese-cns11643-1
			chinese-cns11643-2
			chinese-cns11643-3
			chinese-cns11643-4
			chinese-cns11643-5
			chinese-cns11643-6
			chinese-cns11643-7
			chinese-big5-1
			chinese-big5-2
			korean-ksc5601))))
		   '(latin-jisx0201
		     katakana-jisx0201 thai-tis620 ethiopic
		     indian-is13194 chinese-sisheng lao
		     vietnamese-viscii-lower vietnamese-viscii-upper)
		   (if (fboundp
			(function tibetan-pre-write-canonicalize-for-unicode))
		       '(tibetan))
		   '(mule-unicode-2500-33ff
		     mule-unicode-e000-ffff
		     mule-ucs-unicode-multichar)))
	    (while (setq elem (car cand))
	      (if (or (and (functionp 'charsetp) (charsetp elem))
		      (and (functionp 'find-charset) (find-charset elem))
		      (eq elem 'japanese-jisx0213-1)
		      (eq elem 'japanese-jisx0213-2)
		      (eq elem 'mule-unicode-0100-24ff)
		      (eq elem 'mule-unicode-2500-33ff)
		      (eq elem 'mule-unicode-e000-ffff)
		      (eq elem 'mule-ucs-unicode-multichar))
		  (setq result (cons elem result)))
	      (setq cand (cdr cand)))
	    (nreverse result))))
      (if (and (not (featurep 'xemacs))
	       (>= emacs-major-version 21))
	  (condition-case nil
	      (if (featurep 'un-define)
		  ()
		(require 'ucs-tables) ;; should be before loading `un-define'
		(unify-8859-on-encoding-mode 1)
		(unify-8859-on-decoding-mode -1))
	    (error nil)))
      (require 'un-define)
      (if (featurep 'xemacs)
	  () ;; `un-define-change-charset-order' doesn't work on XEmacs
	;; `un-define-change-charset-order' requires `mucs', and `mucs'
	;; redefines {en,de}code-char and causes problems, such as
	;; (decode-char 'ucs #x00B7) -> nil.  Loading `unicode' prevents it.
	(or (featurep 'mule-ucs-unicode)
	    (load-library "unicode"))
	(when jisx0213-flag
	  (require 'jisx0213)
	  (define-coding-system-alias 'shift_jis-2004 'shift_jisx0213)
	  (define-coding-system-alias 'euc-jis-2004 'euc-jisx0213))
	(un-define-change-charset-order)
	(require 'un-tools))
      ;; define aliases for utf-16
      (define-coding-system-alias 'utf-16le 'utf-16-le-no-signature)
      (define-coding-system-alias 'utf-16be 'utf-16-be-no-signature)
      (define-coding-system-alias 'utf-16le-with-signature 'utf-16-le)
      (define-coding-system-alias 'utf-16be-with-signature 'utf-16-be)
      ;; set coding-category of utf-8 for XEmacs
      (and (featurep 'xemacs)
	   (fboundp 'coding-system-category)
	   (null (coding-system-category 'utf-8))
	   (fboundp 'coding-system-put)
	   (coding-system-put 'utf-8 'category 'utf-8)
	   (coding-system-put 'utf-8-unix 'category 'utf-8)
	   (coding-system-put 'utf-8-dos 'category 'utf-8)
	   (coding-system-put 'utf-8-mac 'category 'utf-8)
	   (coding-system-put 'utf-8-ws 'category 'utf-8)
	   (coding-system-put 'utf-8-ws-unix 'category 'utf-8)
	   (coding-system-put 'utf-8-ws-dos 'category 'utf-8)
	   (coding-system-put 'utf-8-ws-mac 'category 'utf-8)
	   (fboundp 'set-coding-category-system)
	   (set-coding-category-system 'utf-8 'utf-8))
      ;; Reset coding system of terminal
      (if (terminal-coding-system)
	  (set-terminal-coding-system (terminal-coding-system)))
      ;; set coding-priority to use utf-8 auto-detection
      (if (and (coding-system-category 'utf-8)
	       (not (eq (coding-system-category 'utf-8) 'coding-category-ccl)))
	  (let ((alist language-info-alist)
		lang-name codings slot tmp)
	    (while (setq lang-name (car (nth 0 alist)))
	      ;; use copy-sequence so that we can handle read-only object
	      (setq codings (copy-sequence
			     (get-language-info lang-name 'coding-priority)))
	      (setq slot (memq 'mule-utf-8 codings))
	      (if (null slot)
		  (or (memq 'utf-8 codings)
		      (setq codings (append codings '(utf-8))))
		;; use utf-8 rather than mule-utf-8
		(setcdr slot (cons 'utf-8 (cdr slot)))
		(setq codings (delete 'mule-utf-8 codings)))
	      (setq tmp codings)
	      (while tmp (setq tmp (setcdr tmp (delete (car tmp) (cdr tmp)))))
	      (set-language-info lang-name 'coding-priority codings)
	      (setq alist (cdr alist))))))
    ;;
    (setq env (or (getenv "DEB_MULEUCS_UNICODE") "off"))
    (setq unicode-flag
	  (not (string-match "^\\(off\\|no\\|false\\|0\\)$" env)))
    (setq env (or (getenv "DEB_MULEUCS_JISX0213") "off"))
    (setq jisx0213-flag
	  (not (string-match "^\\(off\\|no\\|false\\|0\\)$" env)))
    (setq env (or (getenv "DEB_MULEUCS_PREFER_LATIN") "off"))
    (setq prefer-latin-flag
	  (not (string-match "^\\(off\\|no\\|false\\|0\\)$" env)))
    (if unicode-flag
	(un-define-debian jisx0213-flag prefer-latin-flag))
    ;;
    )))

;;; 40mule-ucs.el ends here
